SetSignProcessCustomSubFilter
Ασφάλεια και Υπογραφές
Περιγραφή
Ορίζει την εγγραφή SubFilter με προσαρμοσμένη συμβολοσειρά για διαδικασία ψηφιακής υπογραφής, καθορίζοντας την κωδικοποίηση της τιμής υπογραφής
Όπως το SetSignProcessSubFilter αλλά η εγγραφή Subfilter είναι προσαρμόσιμη
Όταν η δοθείσα συμβολοσειρά ξεκινά με ETSI. (τυπικά ETSI.CAdES.detached για βασικές υπογραφές PAdES ή ETSI.RFC3161 για χρονικές σημάνσεις εγγράφου) η βιβλιοθήκη προσθέτει αυτόματα την εγγραφή PAdES /Extensions /ESIC <</BaseVersion /1.7 /ExtensionLevel 2>> στον catalog του εγγράφου όπως απαιτεί το ETSI EN 319 142-1 v1.2.1 §5.6. Για PDF συγγραμένα μέσω TPDFlib η ισοδύναμη δήλωση Adobe (/Extensions /ADBE σε /ExtensionLevel 8) προστίθεται παράλληλα. Η έγχυση είναι idempotent και δεν υποβιβάζει ποτέ υπάρχον υψηλότερο επίπεδο επέκτασης.
Η επιλογή ETSI.CAdES.detached ενεργοποιεί επιπλέον τη διαδρομή υπογραφής PAdES-B-B: το προκύπτον CMS payload κουβαλά τα authenticated attributes content-type (id-data) και signing-certificate-v2 (RFC 5035 / RFC 5816), και το attribute signing-time που απαγορεύει ο Table 1 του EN 319 142-1 παραλείπεται επειδή η βιβλιοθήκη δίνει τον δικό της πίνακα attributes στο CryptSignMessage. Το πιστοποιητικό υπογραφής ταυτοποιείται από το digest SHA-256 του (ή SHA-384 / SHA-512 όταν το SetSignProcessDigestAlgorithm διαλέγει μεγαλύτερο hash), και τα τρέχοντα builds περιλαμβάνουν επίσης το προαιρετικό tuple IssuerSerial (distinguished name εκδότη συν αριθμό σειράς) ώστε αυστηρότεροι validators PAdES να διασταυρώνουν το πιστοποιητικό υπογραφής με την υποψήφια αλυσίδα τους.
Σύνταξη
Delphi
Function TPDFlib.SetSignProcessCustomSubFilter(SignProcessID: Integer; SubFilterStr: WideString): Integer;
ActiveX
Function PDFlib::SetSignProcessCustomSubFilter(SignProcessID As Long, SubFilterStr As String) As Long
DLL
int DLSetSignProcessCustomSubFilter(int InstanceID, int SignProcessID, const wchar_t * SubFilterStr);
Παράμετροι
| SignProcessID | Τιμή που επιστρέφουν οι συναρτήσεις NewSignProcessFromFile, NewSignProcessFromStream ή NewSignProcessFromString |
|---|---|
| SubFilterStr | Προσαρμοσμένη εγγραφή συμβολοσειράς SubFilter |
Τιμές επιστροφής
| 0 | Η παράμετρος SignProcessID ήταν άκυρη ή η παράμετρος SubFilter ήταν εκτός εύρους |
|---|---|
| 1 | Success |